#version 330

uniform  sampler2DRect inputTex0;
uniform sampler2DRect inputTexMask;
uniform vec4 endColor;
uniform float endOpacity;

in vec2 fsTexture;
in vec2 fsTextureMask;
out vec4 outColor;


void main()
{
    
#ifdef ARGB
    outColor=texture(inputTex0, fsTexture).argb;
#endif
    
#ifdef ABGR
    outColor=texture(inputTex0, fsTexture).abgr;
#endif

#ifdef BGRA
    outColor=texture(inputTex0, fsTexture).bgra;
#endif
    
#ifdef RGBA
    outColor=texture(inputTex0, fsTexture).rgba;
#endif
    
#ifdef FORCE_ALPHA
    outColor.a=1.0;
#endif

#ifndef NO_PREMULT
    outColor.rgb*=outColor.a;
#endif

#ifdef USE_MASK
    outColor.a*=texture(inputTexMask,fsTextureMask).a;
#endif

#ifdef USE_END_COLOR
    outColor=mix(endColor,outColor,endOpacity);
#endif


}
