constant float4 std709R = float4( 1.793,1.164383, 0.000000,0.0);
constant float4 std709G = float4(-0.534,1.164383,-0.213,0.0);
constant float4 std709B = float4( 0.000000,1.164383, 2.115,0.0);
constant float4 stdbias = float4(-0.5  , -0.0625,  -0.5   ,0.0);

fragment float4 fragmentFunc(inputVertexType in [[stage_in]]
                                 ,texture2d<half> inputTex0 [[ texture(0) ]]
                                 ,texture2d<half> inputTex1 [[ texture(1) ]]
                                 ,texture2d<half> inputTex2 [[ texture(2) ]]
                                 ,texture2d<half> inputTex3 [[ texture(3) ]]
                                 ,texture2d<half> maskTex [[ texture(4) ]]
                                 ,constant planarUniforms& uniforms[[ buffer(0) ]]
)
{
    float4 y0;
    float4 y1;
    
    float isOddUV;
    
    isOddUV = floor(fract(in.texCoordPS.x * 0.5) * 2.0);
    float2 texCoord=in.texCoordY*float2(.5,1.0);
    
#ifdef YUYV
    y0 = float4(inputTex0.sample(nearestSampler,texCoord)).argb;
#endif
    
#ifdef UYVY
    y0 = float4(inputTex0.sample(nearestSampler,texCoord));
#endif

    
    y1=y0;
    y1.g=y0.a;
    y0=mix(y0,y1,isOddUV);
    
    y0+=stdbias;
    
    float4 outColor=float4(dot(std709R, y0),
                  dot(std709G, y0),
                  dot(std709B, y0),
                  1.0);

#ifdef USE_MASK
    outColor.a*=textureFetchNearest(maskTex,in.maskCoord).a;
#endif

#ifdef USE_END_COLOR
    outColor=mix(uniforms.endColor,outColor,uniforms.endOpacity);
#endif

    return outColor;

}
